Package com.smartgwt.client.widgets.form.fields

# Class DateTimeItem

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.core.RefDataClass
com.smartgwt.client.data.Field
com.smartgwt.client.widgets.form.fields.FormItem
com.smartgwt.client.widgets.form.fields.DateItem
com.smartgwt.client.widgets.form.fields.DateTimeItem

All Implemented Interfaces:
  `HasHandlers`, `HasBlurHandlers`, `HasChangedHandlers`, `HasChangeHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasEditorEnterHandlers`, `HasEditorExitHandlers`, `HasFocusHandlers`, `HasIconClickHandlers`, `HasIconKeyPressHandlers`, `HasItemHoverHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasKeyUpHandlers`, `HasPendingStatusChangedHandlers`, `HasPickerIconClickHandlers`, `HasShowContextMenuHandlers`, `HasTitleClickHandlers`, `HasTitleDoubleClickHandlers`, `HasTitleHoverHandlers`, `HasValueHoverHandlers`, `HasValueIconClickHandlers`

public class DateTimeItem extends DateItem
A simple `DateItem subclass` for editing `regular datetime` values, where date and time elements are relevant.

The item edits datetimes directly as text-values, formatted according to your locale and settings such as `DateItem.dateFormatter`.

To edit `logical-Date values`, see `DateItem`, and to edit `logical-time values`, see `TimeItem`. For `relative-date features`, see `RelativeDateItem`.

For detailed information on working with dates, times and datetimes, see the `Date and Time Format and Storage overview`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

  `FormItem.CustomStateGetter, FormItem.StateCustomizer`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

  `configOnly, scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

  ### Fields inherited from class com.smartgwt.client.core.RefDataClass

  `id`

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DateTimeItem()`
  `DateTimeItem(JavaScriptObject jsObj)`
  `DateTimeItem(String name)`
  `DateTimeItem(String name, String title)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `static void`
  `changePickerIconDefaults(FormItemIcon defaults)`
  `String`
  `getBrowserInputType()`
  If `useTextField` is true and browserInputType is set to "datetime", then a native HTML5 local datetime input is used in place of a text input.
  `DateDisplayFormat`
  `getDisplayFormat()`
  This property can be used to customize the format in which datetimes are displayed.
  Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.
  `String`
  `getInputFormat()`
  If `DateItem.useTextField` is `true` this property can be used to specify the input format for date strings.
  `static DateTimeItem`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `Boolean`
  `getUseTextField()`
  This property defaults to true in DateTimeItems and cannot be altered, since editing is via `formatted` text-entry only.
  `DateTimeItem`
  `setBrowserInputType(String browserInputType)`
  If `useTextField` is true and browserInputType is set to "datetime", then a native HTML5 local datetime input is used in place of a text input.
  `static void`
  `setDefaultProperties(DateTimeItem dateTimeItemProperties)`
  Class level method to set the default properties of this class.
  `DateTimeItem`
  `setDisplayFormat(DateDisplayFormat displayFormat)`
  This property can be used to customize the format in which datetimes are displayed.
  Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.
  `DateTimeItem`
  `setInputFormat(String inputFormat)`
  If `DateItem.useTextField` is `true` this property can be used to specify the input format for date strings.

  ### Methods inherited from class com.smartgwt.client.widgets.form.fields.DateItem

  `deselectValue, deselectValue, getAutoUseTextField, getCenturyThreshold, getDateFormatter, getDaySelector, getDaySelectorProperties, getDefaultChooserDate, getEditProxyConstructor, getEndDate, getEnforceDate, getEnforceValueRange, getEnteredValue, getFiscalCalendar, getGenerateValidator, getInvalidDateStringMessage, getItemTitleAlign, getItemTitleOrientation, getMonthSelector, getMonthSelectorProperties, getPickerDefaults, getPickerIconPrompt, getPickerProperties, getPickerTimeItemProperties, getSelectionRange, getSelectorFormat, getShowChooserFiscalYearPicker, getShowChooserWeekPicker, getShowHintInField, getShowItemTitles, getShowPickerIcon, getShowPickerTimeItem, getStartDate, getTextAlign, getTextField, getTextFieldProperties, getUse24HourTime, getUsePlaceholderForHint, getUseSharedPicker, getValueAsDate, getWrapHintText, getYearSelector, getYearSelectorProperties, pendingStatusChanged, selectValue, setAutoUseTextField, setCenturyThreshold, setDateFormatter, setDaySelectorProperties, setDefaultChooserDate, setDefaultProperties, setEditorValueFormatter, setEditorValueParser, setEditProxyConstructor, setEndDate, setEnforceDate, setEnforceValueRange, setFiscalCalendar, setFiscalCalendar, setGenerateValidator, setInvalidDateStringMessage, setItemTitleAlign, setItemTitleOrientation, setMaskDateSeparator, setMonthSelectorProperties, setPickerDefaults, setPickerIconPrompt, setPickerProperties, setPickerTimeItemProperties, setSelectionRange, setSelectorFormat, setShowChooserFiscalYearPicker, setShowChooserWeekPicker, setShowHintInField, setShowItemTitles, setShowPickerIcon, setShowPickerTimeItem, setStartDate, setTextAlign, setTextFieldProperties, setUse24HourTime, setUseMask, setUsePlaceholderForHint, setUseSharedPicker, setUseTextField, setWrapHintText, setYearSelectorProperties`

  ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

  `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIcon, addIcon, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addShowContextMenuHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, applyFormula, asSGWTComponent, blurItem, canEditCriterion, checkFormItemType, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusAfterItem, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getAlwaysShowControlBox, getApplyAlignToText, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getAutoCompleteKeywords, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanFocus, getCanHover, getCanSelectText, getCanTabToIcons, getCanvasAutoChild, getCellHeight, getCellStyle, getChangeOnKeypress, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDefaultOperator, getDefaultValue, getDeferActionConversion, getDestroyed, getDisabled, getDisabledHover, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEnableTitleClickWhenDisabled, getEndRow, getErrorIconHeight, getErrorIconProperties, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getEscapeHTML, getExportFormat, getExtraControlTableCSS, getExtraTextBoxCSS, getFetchMissingValues, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFormula, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHeight, getHeightAsString, getHidden, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHeightAsString, getHoverOpacity, getHoverPersist, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWidthAsString, getIcon, getIconBaseStyle, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIcons, getIconTabPosition, getIconVAlign, getIconWidth, getID, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getLeft, getLinearColSpan, getLinearColSpanAsString, getLinearEndRow, getLinearEndRowAsString, getLinearStartRow, getLinearStartRowAsString, getLinearWidth, getLinearWidthAsString, getListGrid, getLoadingDisplayValue, getLocateItemBy, getMinHintWidth, getMultiple, getMultipleValueSeparator, getName, getNullOriginalValueText, getOperator, getOptionCriteria, getOptionDataSource, getOptionDataSourceAsString, getOptionFilterContext, getOptionOperationId, getOptionTextMatchStyle, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPaletteDefaults, getPermanentlyHidden, getPicker, getPickerEscapeHTML, getPickerIcon, getPickerIcon, getPickerIconHeight, getPickerIconName, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconTabPosition, getPickerIconWidth, getPickerSnapEdge, getPickerSnapTo, getPixelHeight, getPixelWidth, getPrintReadOnlyTextBoxStyle, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyCanSelectText, getReadOnlyControlStyle, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getReadOnlyWhen, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRequiredRightTitlePrefix, getRequiredRightTitleSuffix, getRequiredTitlePrefix, getRequiredTitleSuffix, getRequiredWhen, getRightTitlePrefix, getRightTitleSuffix, getRowSpan, getSaveOnEnter, getScClassName, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShouldSaveValue, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowDisabledIconsOnFocus, getShowDisabledPickerIconOnFocus, getShowErrorIcon, getShowErrorIconInline, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowIconsOnFocus, getShowImageAsURL, getShowOldValueInHover, getShowOver, getShowOverIcons, getShowPending, getShowPickerIconOnFocus, getShowPickerOnFocus, getShowPickerOnFocusDelay, getShowRTL, getShowTitle, getShowValueIconOnly, getShowVoiceAssistIcon, getStartRow, getStaticHeight, getStopOnError, getStoreDisplayValues, getSupportsCutPasteEvents, getSuppressOptionDSFallback, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextBoxStyle, getTextBoxVPad, getTextFormula, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitlePrefix, getTitleStyle, getTitleSuffix, getTitleVAlign, getTooltip, getTop, getTreatEmptyAsNull, getType, getUpdateControlOnOver, getUpdatePickerIconOnOver, getUpdateTextBoxOnOver, getUseAdvancedCriteria, getUseDisabledHintStyleForReadOnly, getUseLocalDisplayFieldValue, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsFloat, getValueAsInteger, getValueAsLong, getValueAsRecordList, getValueDeselectedCSSText, getValueField, getValueFieldName, getValueIconAriaRole, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getValueMap, getValueMapAsArray, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWhen, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapStaticValue, getWrapTitle, handleWarnOnEditorTypeConversion, hasAdvancedCriteria, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isAssignableFrom, isConfigOnly, isCreated, isCutEvent, isDisabled, isDrawn, isFocused, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, removeIcon, selectedRecordChanged, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setAlwaysShowControlBox, setApplyAlignToText, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setAutoCompleteKeywords, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanEditOpaqueValues, setCanFocus, setCanHover, setCanSelectText, setCanTabToIcons, setCellHeight, setCellStyle, setChangeOnKeypress, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setConfigOnly, setControlStyle, setCriteriaField, setCriterion, setCriterionGetter, setCriterionSetter, setCustomStateGetter, setDataPath, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultOperator, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDeferActionConversion, setDisabled, setDisabledHover, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEnableTitleClickWhenDisabled, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconProperties, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setEscapeHTML, setExportFormat, setExtraControlTableCSS, setExtraTextBoxCSS, setFetchMissingValues, setFilterLocally, setForeignDisplayField, setFormat, setFormula, setGlobalTabIndex, setHeight, setHeight, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverHeight, setHoverOpacity, setHoverPersist, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWidth, setIconBaseStyle, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconShowOnFocus, setIconVAlign, setIconWidth, setID, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLinearColSpan, setLinearColSpan, setLinearEndRow, setLinearEndRow, setLinearStartRow, setLinearStartRow, setLinearWidth, setLinearWidth, setLoadingDisplayValue, setLocateItemBy, setMinHintWidth, setMultiple, setMultipleValueSeparator, setName, setNullOriginalValueText, setNullProperty, setOperator, setOptionCriteria, setOptionDataSource, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setOptionTextMatchStyle, setOriginalValueMessage, setPermanentlyHidden, setPickerEscapeHTML, setPickerIconHeight, setPickerIconName, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPickerSnapEdge, setPickerSnapTo, setPrintReadOnlyTextBoxStyle, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyCanSelectText, setReadOnlyControlStyle, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setReadOnlyWhen, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRequiredRightTitlePrefix, setRequiredRightTitleSuffix, setRequiredTitlePrefix, setRequiredTitleSuffix, setRequiredWhen, setRightTitlePrefix, setRightTitleSuffix, setRowSpan, setSaveOnEnter, setScClassName, setSelectOnClick, setSelectOnFocus, setShouldSaveValue, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowDisabledIconsOnFocus, setShowDisabledPickerIconOnFocus, setShowErrorIcon, setShowErrorIconInline, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIconsOnFocus, setShowIfCondition, setShowImageAsURL, setShowOldValueInHover, setShowOver, setShowOverIcons, setShowPending, setShowPickerIconOnFocus, setShowPickerOnFocus, setShowPickerOnFocusDelay, setShowRTL, setShowTitle, setShowValueIconOnly, setShowVoiceAssistIcon, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setStoreDisplayValues, setSupportsCutPasteEvents, setSuppressOptionDSFallback, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextBoxStyle, setTextBoxVPad, setTextFormula, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitlePrefix, setTitleStyle, setTitleSuffix, setTitleVAlign, setTooltip, setTop, setTreatEmptyAsNull, setType, setUpdateControlOnOver, setUpdatePickerIconOnOver, setUpdateTextBoxOnOver, setUseAdvancedCriteria, setUseDisabledHintStyleForReadOnly, setUseLocalDisplayFieldValue, setUseObjectFactoryForTypeFallback, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueByDisplayValue, setValueByDisplayValue, setValueDeselectedCSSText, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconAriaRole, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setVisibleWhen, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapStaticValue, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, storeValue, updateState, validate, valueClipped`

  ### Methods inherited from class com.smartgwt.client.data.Field

  `getCanExport, getExportTitle, getPrimaryKey, getSortByField, setCanExport, setExportTitle, setPrimaryKey, setSortByField`

  ### Methods inherited from class com.smartgwt.client.core.RefDataClass

  `getRef, getRef, internalSetID`

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### DateTimeItem

    public DateTimeItem()

  - ### DateTimeItem

    public DateTimeItem(JavaScriptObject jsObj)

  - ### DateTimeItem

    public DateTimeItem(String name)

  - ### DateTimeItem

    public DateTimeItem(String name, String title)

- ## Method Details

  - ### getOrCreateRef

    public static DateTimeItem getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changePickerIconDefaults

    public static void changePickerIconDefaults(FormItemIcon defaults)

  - ### setBrowserInputType

    public DateTimeItem setBrowserInputType(String browserInputType)
    If `useTextField` is true and browserInputType is set to "datetime", then a native HTML5 local datetime input is used in place of a text input.

    The use of a native HTML5 datetime input causes certain features to be disabled. Input masks, the picker icon, and a custom `datetimeFormatter` are not supported. In-field hints are currently supported in Chrome/Chromium/Opera 15 and iOS 5.0+, but future browser changes might force this support to be removed. Therefore, it is safest to not use in-field hints (set showHintInField to false) in conjunction with a native HTML5 datetime input. In-field hints are not supported in Opera 12 when using a native HTML5 datetime input. If in-field hints are not supported in the browser, then showHintInField has no effect and any hint will be shown to the side of the input.

    NOTES:

    - This feature requires specific CSS changes. Currently these changes have been made to the Enterprise, EnterpriseBlue, and Graphite skins only.
    - In Chrome/Chromium/Opera 15 and Opera 12, native datetime inputs need to be made wider in order to fit the full datetime value within the native control. However, on iOS 5.0+, the normal width is fine. Be sure to test the layout of the form in all browsers that you wish to support.

    Note : This is an advanced setting

    Overrides:
      `setBrowserInputType` in class `DateItem`
    Parameters:
      `browserInputType` - New browserInputType value. Default value is null
    Returns:
      `DateTimeItem` instance, for chaining setter calls

  - ### getBrowserInputType

    public String getBrowserInputType()
    If `useTextField` is true and browserInputType is set to "datetime", then a native HTML5 local datetime input is used in place of a text input.

    The use of a native HTML5 datetime input causes certain features to be disabled. Input masks, the picker icon, and a custom `datetimeFormatter` are not supported. In-field hints are currently supported in Chrome/Chromium/Opera 15 and iOS 5.0+, but future browser changes might force this support to be removed. Therefore, it is safest to not use in-field hints (set showHintInField to false) in conjunction with a native HTML5 datetime input. In-field hints are not supported in Opera 12 when using a native HTML5 datetime input. If in-field hints are not supported in the browser, then showHintInField has no effect and any hint will be shown to the side of the input.

    NOTES:

    - This feature requires specific CSS changes. Currently these changes have been made to the Enterprise, EnterpriseBlue, and Graphite skins only.
    - In Chrome/Chromium/Opera 15 and Opera 12, native datetime inputs need to be made wider in order to fit the full datetime value within the native control. However, on iOS 5.0+, the normal width is fine. Be sure to test the layout of the form in all browsers that you wish to support.
    Overrides:
      `getBrowserInputType` in class `DateItem`
    Returns:
      Current browserInputType value. Default value is null

  - ### setDisplayFormat

    public DateTimeItem setDisplayFormat(DateDisplayFormat displayFormat)
    This property can be used to customize the format in which datetimes are displayed.
    Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.

    If unset, the standard shortDateTime format as set up in `DateUtil.setShortDatetimeDisplayFormat()` will be used.

    NOTE: you may need to update the `inputFormat` to ensure the DateItem is able to parse user-entered date strings back into Dates

    Overrides:
      `setDisplayFormat` in class `FormItem`
    Parameters:
      `displayFormat` - New displayFormat value. Default value is null
    Returns:
      `DateTimeItem` instance, for chaining setter calls
    See Also:
      - `setInputFormat(java.lang.String)`

  - ### getDisplayFormat

    public DateDisplayFormat getDisplayFormat()
    This property can be used to customize the format in which datetimes are displayed.
    Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.

    If unset, the standard shortDateTime format as set up in `DateUtil.setShortDatetimeDisplayFormat()` will be used.

    NOTE: you may need to update the `inputFormat` to ensure the DateItem is able to parse user-entered date strings back into Dates

    Returns:
      Current displayFormat value. Default value is null
    See Also:
      - `getInputFormat()`

  - ### setInputFormat

    public DateTimeItem setInputFormat(String inputFormat)
    If `DateItem.useTextField` is `true` this property can be used to specify the input format for date strings. If unset, the input format will be determined based on the specified `DateItem.dateFormatter` if possible (see `DateItem.getInputFormat()`), otherwise picked up from the Date class (see `DateUtil.setInputFormat()`).

    Should be set to a standard `DateInputFormat`

    Note that the `DateInputFormat` property is sufficient to parse date or datetime strings specified in most standard date formats. However should an entirely custom parsing function be required developers can apply a custom `editorValueParser` function.

    This attribute does not have an effect if a native HTML5 date input is being used. See `DateItem.browserInputType`.

    Overrides:
      `setInputFormat` in class `DateItem`
    Parameters:
      `inputFormat` - New inputFormat value. Default value is null
    Returns:
      `DateTimeItem` instance, for chaining setter calls
    See Also:
      - `DateItem.setDateFormatter(com.smartgwt.client.types.DateDisplayFormat)`
      - `DateInputFormat`

  - ### getInputFormat

    public String getInputFormat()
    If `DateItem.useTextField` is `true` this property can be used to specify the input format for date strings. If unset, the input format will be determined based on the specified `DateItem.dateFormatter` if possible (see `DateItem.getInputFormat()`), otherwise picked up from the Date class (see `DateUtil.setInputFormat()`).

    Should be set to a standard `DateInputFormat`

    Note that the `DateInputFormat` property is sufficient to parse date or datetime strings specified in most standard date formats. However should an entirely custom parsing function be required developers can apply a custom `editorValueParser` function.

    This attribute does not have an effect if a native HTML5 date input is being used. See `DateItem.browserInputType`.

    Overrides:
      `getInputFormat` in class `DateItem`
    Returns:
      Current inputFormat value. Default value is null
    See Also:
      - `DateItem.getDateFormatter()`
      - `DateInputFormat`

  - ### getUseTextField

    public Boolean getUseTextField()
    This property defaults to true in DateTimeItems and cannot be altered, since editing is via `formatted` text-entry only.
    Overrides:
      `getUseTextField` in class `DateItem`
    Returns:
      Current useTextField value. Default value is true
    See Also:
      - Date Example

  - ### setDefaultProperties

    public static void setDefaultProperties(DateTimeItem dateTimeItemProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `dateTimeItemProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`